import NDK, { NDKPrivateKeySigner } from '@nostr-dev-kit/ndk'
import cron from 'node-cron'

console.log(`Bot is starting...`)

const signer = new NDKPrivateKeySigner('key') // Add private key

const ndk = new NDK({
  explicitRelayUrls: ['wss://relay.example.com'], // Add relay
  signer
})

// Function to create a message based on the day
const createMessage = () => {
  const today = new Date()
  const dayOfWeek = today.getDay() // 0 is Sunday, 1 is Monday, ..., 6 is Saturday

  // Check if it's the weekend (Saturday or Sunday)
  if (dayOfWeek === 0 || dayOfWeek === 6) {
    return 'gfy fiatjaf'
  } else {
    return 'GM fiatjaf'
  }
}

// Schedule the bot to post every other day (e.g., "0 0 */2 * *" means every other day)
cron.schedule('0 0 */2 * *', async () => {
  const message = createMessage()

  const event = new NDKEvent(ndk, {
    kind: 1, // Kind 1 is a "text note"
    tags: [['p', pk]],
    content: message,
    created_at: Math.floor(Date.now() / 1000)
  })

  // sign the authorization event
  await event.sign().catch((err) => {
    throw new Error(`Event signing error: ${err}`)
  })

  await relay.publish(signedEvent).catch((err) => {
    console.error('Error sending NOSTR event:', err)
  })
  console.log(`Event published.`)
})

console.log('Bot started. Will post every other day.')
